跳到主要内容

与 React 集成

提示

请确保您已熟悉 React 的基本概念和模式。如需复习,请参阅 React 文档。

DHTMLX RichText 支持与 React 配合使用。完整的代码示例请参见 GitHub 演示。

创建项目​

信息

在创建新项目之前,请先安装 Node.js 以及(可选)Vite。

使用 Create React App 创建一个新的 my-react-richtext-app 项目:

npx create-react-app my-react-richtext-app

安装依赖​

切换到新的应用目录:

cd my-react-richtext-app

使用包管理器安装依赖并启动开发服务器。

使用 yarn 时,运行:

yarn
yarn start

使用 npm 时,运行:

npm install
npm start

应用将在本地运行(例如 http://localhost:3000)。

创建 RichText​

停止应用并安装 RichText 包。

第一步:安装包​

下载 试用版 RichText 包 并按照 README 文件中的步骤操作。试用许可证有效期为 30 天。

第二步:创建组件​

创建一个 React 组件以将 RichText 添加到应用中。在 src/ 目录下,创建一个名为 Richtext.jsx 的新文件。

导入源文件​

打开 Richtext.jsx 并导入 RichText 源文件。

对于从本地文件夹安装的 PRO 版本,请使用:

Richtext.jsx
import { Richtext } from 'dhx-richtext-package';
import 'dhx-richtext-package/dist/richtext.css';

对于试用版,请使用:

Richtext.jsx
import { Richtext } from '@dhx/trial-richtext';
import "@dhx/trial-richtext/dist/richtext.css";

本教程使用 RichText 的试用版本。

设置容器并初始化 RichText​

为 RichText 设置一个容器元素,并在 useEffect() 内使用 Richtext 构造函数初始化组件。在清理函数中调用 destructor() 方法以销毁 RichText:

Richtext.jsx
import { useEffect, useRef } from "react";
import { Richtext } from '@dhx/trial-richtext';
import '@dhx/trial-richtext/dist/richtext.css'; // 引入 RichText 样式

export default function RichTextComponent(props) {
let richtext_container = useRef(); // RichText 的容器

useEffect(() => {
// 初始化 RichText 组件
const editor = new Richtext(richtext_container.current, {});

return () => {
editor.destructor(); // 销毁 RichText
};
}, []);

return <div className="component_container">
<div ref={richtext_container} className="widget"></div>
</div>
}

添加样式​

将 RichText 及其容器的样式添加到项目的主 CSS 文件中:

index.css
/* 页面基础样式 */
html,
body,
#root {
height: 100%;
padding: 0;
margin: 0;
}

/* RichText 容器 */
.component_container {
height: 100%;
margin: 0 auto;
}

/* RichText 控件 */
.widget {
height: calc(100% - 56px);
}

加载数据​

为 RichText 提供数据。在 src/ 目录下创建 data.js 文件:

data.js
export function getData() {
const value = `
<h2>RichText 2.0</h2>
<p>Repository at <a href="https://git.webix.io/xbs/richtext">https://git.webix.io/xbs/richtext</a></p>
<p><img src="https://placecats.com/500/300" style={{width: '500px', height: '300px'}}></p>`;
return { value };
}

打开 App.js 并导入数据,将值作为 prop 传递给 <RichText/> 组件:

App.js
import RichText from "./Richtext";
import { getData } from "./data";

function App() {
const { value } = getData();
return <RichText value={value} />;
}

export default App;

打开 Richtext.jsx 并将 props.value 传入 RichText 配置:

Richtext.jsx
import { useEffect, useRef } from "react";
import { Richtext } from "@dhx/trial-richtext";
import "@dhx/trial-richtext/dist/richtext.css";

export default function RichTextComponent(props) {
let richtext_container = useRef();

useEffect(() => {
const editor = new Richtext(richtext_container.current, {
value: props.value, // 应用值
// 其他配置属性
});

return () => {
editor.destructor();
};
}, []);

return <div className="component_container">
<div ref={richtext_container} className="widget"></div>
</div>
}

或者,在 useEffect() 内调用 setValue() 方法将数据加载到 RichText 中:

Richtext.jsx
import { useEffect, useRef } from "react";
import { Richtext } from "@dhx/trial-richtext";
import "@dhx/trial-richtext/dist/richtext.css";

export default function RichTextComponent(props) {
let richtext_container = useRef();

let value = props.value;

useEffect(() => {
const editor = new Richtext(richtext_container.current, {
// 配置属性
});

editor.setValue(value);

return () => {
editor.destructor();
};
}, []);

return <div className="component_container">
<div ref={richtext_container} className="widget"></div>
</div>
}

RichText 组件现已可以使用。当 <RichText/> 元素挂载时,React 会渲染带有数据的编辑器。完整的配置选项列表请参见 RichText API 概览。

处理事件​

RichText 会在用户操作时触发事件。使用 api.on() 方法订阅事件以响应用户输入。请参见完整事件列表。

打开 Richtext.jsx 并更新 useEffect() 钩子。以下示例在每次触发 print 事件时记录一条消息:

Richtext.jsx
// ...
useEffect(() => {
const editor = new Richtext(richtext_container.current, {});

editor.api.on("print", () => {
console.log("The document is printing");
});

return () => {
editor.destructor();
};
}, []);
// ...

启动应用,即可看到 RichText 在页面上渲染并显示数据。

在 React 应用程序中渲染的 DHTMLX RichText(含示例内容)

现在您已在 React 中完成了 RichText 的集成。请根据需要自定义代码。完整示例可在 GitHub 上获取。

跳到主要内容

与 Angular 集成

提示

请确保您已熟悉 Angular 的基本概念和模式。如需复习,请参阅 Angular 文档。

DHTMLX RichText 可与 Angular 配合使用。完整的代码示例请参见 GitHub 演示。

创建项目​

信息

在创建新项目之前,请先安装 Angular CLI 和 Node.js。

使用 Angular CLI 创建一个名为 my-angular-richtext-app 的新项目:

ng new my-angular-richtext-app
备注

在项目创建过程中,当 Angular CLI 提示时,请禁用服务端渲染(SSR)和静态站点生成(SSG/Prerendering)。

该命令会安装所有必要的工具,无需执行其他命令。

安装依赖​

切换到新应用的目录:

cd my-angular-richtext-app

使用 yarn 包管理器安装依赖并启动开发服务器:

yarn
yarn start

应用将在 localhost 上运行(例如 http://localhost:3000)。

创建 RichText​

停止应用并安装 RichText 包。

第一步:安装包​

下载 RichText 试用包 并按照 README 文件中的步骤操作。试用许可证有效期为 30 天。

第二步:创建组件​

创建一个 Angular 组件,将 RichText 添加到应用中。在 src/app/ 目录下,创建 richtext 文件夹,并添加一个名为 richtext.component.ts 的新文件。

导入源文件​

打开 richtext.component.ts 并导入 RichText 源文件。

对于从本地文件夹安装的 PRO 版本,请使用:

import { Richtext } from 'dhx-richtext-package';

对于试用版本,请使用:

import { Richtext } from '@dhx/trial-richtext';

本教程使用 RichText 的试用版本。

设置容器并初始化 RichText​

为 RichText 设置容器元素,并在 ngOnInit() 中使用 Richtext 构造函数初始化组件。在 ngOnDestroy() 中调用 destructor() 方法进行清理:

richtext.component.ts
import { Richtext } from '@dhx/trial-richtext';
import { Component, ElementRef, OnInit, ViewChild, OnDestroy, ViewEncapsulation } from '@angular/core';

@Component({
encapsulation: ViewEncapsulation.None,
selector: "richtext", // 在 app.component.ts 中以 <richtext /> 的形式使用 "richtext" 选择器
styleUrls: ["./richtext.component.css"], // 引入 css 文件
template: `<div class = "component_container">
<div #richtext_container class = "widget"></div>
</div>`
})

export class RichTextComponent implements OnInit, OnDestroy {
// RichText 的容器
@ViewChild("richtext_container", { static: true }) richtext_container!: ElementRef;

private _editor!: Richtext;

ngOnInit() {
// 初始化 RichText 组件
this._editor = new Richtext(this.richtext_container.nativeElement, {});
}

ngOnDestroy(): void {
this._editor.destructor(); // 销毁 RichText
}
}

添加样式​

在 src/app/richtext/ 目录下创建 richtext.component.css 文件,为 RichText 及其容器添加样式:

richtext.component.css
/* 导入 RichText 样式 */
@import "@dhx/trial-richtext/dist/richtext.css";

/* 页面基础样式 */
html,
body{
height: 100%;
padding: 0;
margin: 0;
}

/* RichText 容器 */
.component_container {
height: 100%;
margin: 0 auto;
}

/* RichText 控件 */
.widget {
height: calc(100% - 56px);
}

加载数据​

为 RichText 提供数据。在 src/app/richtext/ 目录下创建 data.ts 文件:

data.ts
export function getData() {
const value = `
<h2>RichText 2.0</h2>
<p>Repository at <a href="https://git.webix.io/xbs/richtext">https://git.webix.io/xbs/richtext</a></p>
<p><img src="https://placecats.com/500/300" style={{width: '500px', height: '300px'}}></p>`;
return { value };
}

打开 richtext.component.ts,导入数据并在 ngOnInit() 中将 value 属性传递给 RichText 配置:

richtext.component.ts
import { Richtext } from '@dhx/trial-richtext';
import { getData } from "./data"; // 导入数据
import { Component, ElementRef, OnInit, ViewChild, OnDestroy, ViewEncapsulation } from '@angular/core';

@Component({
encapsulation: ViewEncapsulation.None,
selector: "richtext",
styleUrls: ["./richtext.component.css"],
template: `<div class = "component_container">
<div #richtext_container class = "widget"></div>
</div>`
})

export class RichTextComponent implements OnInit, OnDestroy {
@ViewChild("richtext_container", { static: true }) richtext_container!: ElementRef;

private _editor!: Richtext;

ngOnInit() {
const { value } = getData(); // 从 data 模块中提取值
this._editor = new Richtext(this.richtext_container.nativeElement, {
value
// 其他配置属性
});
}

ngOnDestroy(): void {
this._editor.destructor();
}
}

或者,在 ngOnInit() 中调用 setValue() 方法向 RichText 加载数据:

richtext.component.ts
import { Richtext } from '@dhx/trial-richtext';
import { getData } from "./data"; // 导入数据
import { Component, ElementRef, OnInit, ViewChild, OnDestroy, ViewEncapsulation } from '@angular/core';

@Component({
encapsulation: ViewEncapsulation.None,
selector: "richtext",
styleUrls: ["./richtext.component.css"],
template: `<div class = "component_container">
<div #richtext_container class = "widget"></div>
</div>`
})

export class RichTextComponent implements OnInit, OnDestroy {
@ViewChild("richtext_container", { static: true }) richtext_container!: ElementRef;

private _editor!: Richtext;

ngOnInit() {
const { value } = getData(); // 从 data 模块中提取值
this._editor = new Richtext(this.richtext_container.nativeElement, {
// 其他配置属性
});

// 通过 setValue() 方法应用数据
this._editor.setValue(value);
}

ngOnDestroy(): void {
this._editor.destructor();
}
}

RichText 组件现已准备就绪。当 <richtext/> 元素挂载时,Angular 会渲染带有数据的编辑器。完整的配置选项列表请参见 RichText API 概览。

处理事件​

RichText 会在用户操作时触发事件。使用 api.on() 方法订阅事件以响应用户输入。请参见完整的事件列表。

打开 richtext.component.ts 并更新 ngOnInit() 方法。以下示例在每次触发 print 事件时记录一条消息:

richtext.component.ts
// ...
ngOnInit() {
this._editor = new Richtext(this.richtext_container.nativeElement, {});

this._editor.api.on("print", () => {
console.log("The document is printing");
});
}

ngOnDestroy(): void {
this._editor.destructor();
}

第三步:将 RichText 添加到应用​

打开 src/app/app.component.ts,将默认代码替换为 <richtext/> 选择器:

app.component.ts
import { Component } from "@angular/core";

@Component({
selector: "app-root",
template: `<richtext/>`
})
export class AppComponent {
name = "";
}

创建 src/app/app.module.ts 并声明 RichTextComponent:

app.module.ts
import { NgModule } from "@angular/core";
import { BrowserModule } from "@angular/platform-browser";

import { AppComponent } from "./app.component";
import { RichTextComponent } from "./richtext/richtext.component";

@NgModule({
declarations: [AppComponent, RichTextComponent],
imports: [BrowserModule],
bootstrap: [AppComponent]
})
export class AppModule {}

打开 src/main.ts 并将内容替换为引导代码:

main.ts
import { platformBrowserDynamic } from "@angular/platform-browser-dynamic";
import { AppModule } from "./app/app.module";
platformBrowserDynamic()
.bootstrapModule(AppModule)
.catch((err) => console.error(err));

启动应用,查看 RichText 在页面上渲染并显示数据。

在 Angular 应用程序中渲染的 DHTMLX RichText(含示例内容)

您现在已在 Angular 中完成了 RichText 的集成。请根据您的需求自定义代码。完整示例可在 GitHub 上获取。

跳到主要内容

与 Svelte 集成

提示

请确保您已熟悉 Svelte 的基本概念和模式。如需复习,请参阅 Svelte 文档。

DHTMLX RichText 可与 Svelte 配合使用。完整的代码示例请参见 GitHub 演示。

创建项目​

信息

在创建新项目之前,请先安装 Node.js,以及可选安装 Vite。

本教程使用基于 Vite 的 Svelte 项目。关于 SvelteKit 及其他选项,请参阅 Svelte 项目指南。

创建一个新的 Vite 项目:

npm create vite@latest

安装依赖​

当脚手架工具提示输入项目名称时,使用 my-svelte-richtext-app。然后切换到新目录:

cd my-svelte-richtext-app

使用包管理器安装依赖并启动开发服务器。

使用 yarn 时,运行:

yarn
yarn dev

使用 npm 时,运行:

npm install
npm run dev

应用将在 localhost 上运行(例如 http://localhost:3000)。

创建 RichText​

停止应用并安装 RichText 包。

第一步:安装包​

下载 RichText 试用包 并按照 README 文件中的步骤操作。试用许可证有效期为 30 天。

第二步:创建组件​

创建一个 Svelte 组件,将 RichText 添加到应用中。在 src/ 目录下,创建名为 Richtext.svelte 的新文件。

导入源文件​

打开 Richtext.svelte 并导入 RichText 源文件。

对于从本地文件夹安装的 PRO 版本,使用:

Richtext.svelte
<script>
import { Richtext } from 'dhx-richtext-package';
import 'dhx-richtext-package/dist/richtext.css';
</script>

对于试用版本,使用:

Richtext.svelte
<script>
import { Richtext } from '@dhx/trial-richtext';
import '@dhx/trial-richtext/dist/richtext.css';
</script>

本教程使用 RichText 试用版本。

设置容器并初始化 RichText​

为 RichText 设置一个容器元素,并在 onMount() 中初始化组件。在 onDestroy() 中调用 destructor() 方法以移除 RichText:

Richtext.svelte
<script>
import { onMount, onDestroy } from "svelte";
import { Richtext } from "@dhx/trial-richtext";
import "@dhx/trial-richtext/dist/richtext.css";

let richtext_container; // RichText 的容器
let editor;

onMount(() => {
// 初始化 RichText 组件
editor = new Richtext(richtext_container, {});
});

onDestroy(() => {
editor?.destructor(); // 销毁 RichText
});
</script>

<div class="component_container">
<div bind:this={richtext_container} class="widget"></div>
</div>

添加样式​

将 RichText 及其容器的样式添加到项目的主 CSS 文件中(例如 src/app.css):

app.css
/* 基础页面样式 */
html,
body {
height: 100%;
padding: 0;
margin: 0;
}

/* RichText 容器 */
.component_container {
height: 100%;
margin: 0 auto;
}

/* RichText 控件 */
.widget {
height: calc(100% - 56px);
}

加载数据​

为 RichText 提供数据。在 src/ 目录下创建 data.js 文件:

data.js
export function getData() {
const value = `
<h2>RichText 2.0</h2>
<p>Repository at <a href="https://git.webix.io/xbs/richtext">https://git.webix.io/xbs/richtext</a></p>
<p><img src="https://placecats.com/500/300" style={{width: '500px', height: '300px'}}></p>`;
return { value };
}

打开 App.svelte,导入数据,并将 value 作为 prop 传递给 <RichText/> 组件:

App.svelte
<script>
import RichText from "./Richtext.svelte";
import { getData } from "./data.js";

const { value } = getData();
</script>

<RichText value={value} />

打开 Richtext.svelte,将 prop 值传入 RichText 配置:

Richtext.svelte
<script>
import { onMount, onDestroy } from "svelte";
import { Richtext } from "@dhx/trial-richtext";
import "@dhx/trial-richtext/dist/richtext.css";

export let value;

let richtext_container;
let editor;

onMount(() => {
editor = new Richtext(richtext_container, {
value
// 其他配置属性
});
});

onDestroy(() => {
editor?.destructor();
});
</script>

<div class="component_container">
<div bind:this={richtext_container} class="widget"></div>
</div>

或者,在 onMount() 中调用 setValue() 方法将数据加载到 RichText:

Richtext.svelte
<script>
import { onMount, onDestroy } from "svelte";
import { Richtext } from "@dhx/trial-richtext";
import "@dhx/trial-richtext/dist/richtext.css";

export let value;

let richtext_container;
let editor;

onMount(() => {
editor = new Richtext(richtext_container, {
// 其他配置属性
});

editor.setValue(value);
});

onDestroy(() => {
editor?.destructor();
});
</script>

<div class="component_container">
<div bind:this={richtext_container} class="widget"></div>
</div>

RichText 组件现已准备好使用。当 <RichText/> 元素挂载时,Svelte 会将带有数据的编辑器渲染出来。有关完整的配置选项列表,请参阅 RichText API 概述。

处理事件​

RichText 会在用户操作时触发事件。使用 api.on() 方法订阅事件以响应用户输入。请参阅完整事件列表。

打开 Richtext.svelte 并更新 onMount() 钩子。以下示例在每次触发 print 事件时记录一条日志:

Richtext.svelte
<script>
// ...
let editor;

onMount(() => {
editor = new Richtext(richtext_container, {});

editor.api.on("print", () => {
console.log("The document is printing");
});
});

onDestroy(() => {
editor?.destructor();
});
</script>

// ...

启动应用,查看 RichText 在页面上渲染数据的效果。

在 Svelte 应用程序中渲染的 DHTMLX RichText(含示例内容)

现在您已在 Svelte 中实现了一个可正常运行的 RichText 集成。请根据需求自定义代码。完整示例可在 GitHub 上获取。

跳到主要内容

与 Vue 集成

提示

请确保您已熟悉基本的 Vue 概念和模式。如需复习,请参阅 Vue 3 文档。

DHTMLX RichText 可与 Vue 配合使用。完整代码示例请参见 GitHub 演示。

创建项目​

信息

在创建新项目之前,请先安装 Node.js。

使用官方脚手架工具创建 Vue 项目:

npm create vue@latest

该命令会安装并运行 create-vue。当脚手架提示输入项目名称时,使用 my-vue-richtext-app。详情请参阅 Vue.js 快速入门。

安装依赖​

切换到应用目录:

cd my-vue-richtext-app

使用包管理器安装依赖并启动开发服务器。

使用 yarn,运行:

yarn
yarn dev

使用 npm,运行:

npm install
npm run dev

应用将在 localhost 上运行(例如,http://localhost:3000)。

创建 RichText​

停止应用并安装 RichText 包。

第一步:安装包​

下载 RichText 试用包 并按照 README 文件中的步骤操作。试用许可证有效期为 30 天。

第二步:创建组件​

创建一个 Vue 组件以将 RichText 添加到应用中。在 src/components/ 目录下,创建一个名为 Richtext.vue 的新文件。

导入源文件​

打开 Richtext.vue 并导入 RichText 源文件。

对于从本地文件夹安装的 PRO 版本,使用:

Richtext.vue
<script>
import { Richtext } from 'dhx-richtext-package';
import 'dhx-richtext-package/dist/richtext.css';
</script>

对于试用版本,使用:

Richtext.vue
<script>
import { Richtext } from '@dhx/trial-richtext';
import '@dhx/trial-richtext/dist/richtext.css';
</script>

本教程使用 RichText 的试用版本。

设置容器并初始化 RichText​

为 RichText 设置容器元素,并在 mounted() 中使用 Richtext 构造函数初始化组件。在 unmounted() 中调用 destructor() 方法以移除 RichText:

Richtext.vue
<script>
import { Richtext } from "@dhx/trial-richtext";
import "@dhx/trial-richtext/dist/richtext.css";

export default {
mounted() {
// 初始化 RichText 组件
this.editor = new Richtext(this.$refs.richtext_container, {});
},

unmounted() {
this.editor.destructor(); // 销毁 RichText
}
};
</script>

<template>
<div class="component_container">
<div ref="richtext_container" class="widget"></div>
</div>
</template>

添加样式​

将 RichText 及其容器的样式添加到项目的主 CSS 文件中:

main.css
/* 基础页面样式 */
html,
body,
#app { /* 使用 #app 根容器 */
height: 100%;
padding: 0;
margin: 0;
}

/* RichText 容器 */
.component_container {
height: 100%;
margin: 0 auto;
}

/* RichText 控件 */
.widget {
height: calc(100% - 56px);
}

加载数据​

为 RichText 提供数据。在 src/ 目录下创建 data.js 文件:

data.js
export function getData() {
const value = `
<h2>RichText 2.0</h2>
<p>Repository at <a href="https://git.webix.io/xbs/richtext">https://git.webix.io/xbs/richtext</a></p>
<p><img src="https://placecats.com/500/300" style={{width: '500px', height: '300px'}}></p>`;
return { value };
}

打开 App.vue,导入数据,并通过 data() 方法初始化。将值作为 prop 传递给 <RichText/> 组件:

App.vue
<script>
import RichText from "./components/Richtext.vue";
import { getData } from "./data";

export default {
components: { RichText },
data() {
const { value } = getData();
return { value };
}
};
</script>

<template>
<RichText :value="value" />
</template>

打开 Richtext.vue 并将 prop 值传递给 RichText 配置:

Richtext.vue
<script>
import { Richtext } from "@dhx/trial-richtext";
import "@dhx/trial-richtext/dist/richtext.css";

export default {
props: ["value"],

mounted() {
this.editor = new Richtext(this.$refs.richtext_container, {
value: this.value,
// 其他配置属性
});
},

unmounted() {
this.editor.destructor();
}
};
</script>

<template>
<div class="component_container">
<div ref="richtext_container" class="widget"></div>
</div>
</template>

或者,在 mounted() 中调用 setValue() 方法将数据加载到 RichText 中:

Richtext.vue
<script>
import { Richtext } from "@dhx/trial-richtext";
import "@dhx/trial-richtext/dist/richtext.css";

export default {
props: ["value"],

mounted() {
this.editor = new Richtext(this.$refs.richtext_container, {
// 其他配置属性
});

this.editor.setValue(this.value);
},

unmounted() {
this.editor.destructor();
}
};
</script>

<template>
<div class="component_container">
<div ref="richtext_container" class="widget"></div>
</div>
</template>

RichText 组件已准备好使用。当 <RichText/> 元素挂载时,Vue 会渲染带有数据的编辑器。完整的配置选项列表,请参阅 RichText API 概览。

处理事件​

RichText 会在用户操作时触发事件。使用 api.on() 方法订阅事件以响应用户输入。请参阅完整事件列表。

打开 Richtext.vue 并更新 mounted() 钩子。以下示例在每次 print 事件触发时记录一条消息:

Richtext.vue
<script>
// ...
export default {
// ...
mounted() {
this.editor = new Richtext(this.$refs.richtext_container, {});

this.editor.api.on("print", () => {
console.log("The document is printing");
});
},

unmounted() {
this.editor.destructor();
}
}
</script>

// ...

启动应用,查看 RichText 在页面上渲染数据的效果。

在 Vue 应用程序中渲染的 DHTMLX RichText(含示例内容)

您现在已在 Vue 中完成 RichText 的集成。可根据需要自定义代码。完整示例可在 GitHub 上获取。